<template>
    <b-container>
        <h3>Classifica ultima settimana</h3>
        <b-table
            id="table"
            bordered
            striped
            hover
            fixed
            :items="politici"
            :fields="fields"
        ></b-table>
    </b-container>
</template>

<script>
import axios from 'axios'

export default {
    name: 'LastWeekComponent',
    data() {
        return {
            politici: [],
            fields: [
                {key: "position", label: "Posizione", sortable: true},
                {key: "surname", label: "Cognome", sortable: true},
                {key: "name", label: "Nome", sortable: false},
                {key: "points", label: "Punti Assegnati", sortable: true},
            ],
        }
    },
    methods: {
        convertDateFormat(date) {
            let dd = String(date.getDate()).padStart(2, '0')
            let mm = String(date.getMonth() + 1).padStart(2,'0')
            let yyyy = date.getFullYear()
            let result = yyyy + '-' + mm + '-' + dd
            return (result)
        },
        getDateXDaysAgo: function(x) {
            let date = new Date()
            let last = new Date(date.getTime() - (x * 24 * 60 * 60 * 1000))
            let result = this.convertDateFormat(last)
            return (result)
        },
        classifica: async function() {
            const today = this.convertDateFormat(new Date())
            const minDate = this.getDateXDaysAgo(7)
            let res = await axios.get("http://localhost:8000/api/v1/getranking/"+minDate+"/"+today)
            this.politici = res.data
            console.log(res.data)
        },
    },
    created: async function () {
        await this.classifica();
    }
}
</script>

<style scoped>
h3 {
    margin-bottom: 1rem;
}
</style>